---
title: 'SVGGraphicsElement: paste event'
slug: Web/API/SVGGraphicsElement/paste_event
tags:
  - API
  - Event
  - Reference
  - SVG
  - SVG OM
---
<div>{{APIRef}}</div>

<p><span class="seoSummary">The <strong><code>paste</code></strong> event is fired on an {{domxref("SVGGraphicsElement")}} when the user has initiated a "paste" action through the browser's user interface.</span></p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("ClipboardEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("SVGGraphicsElement/onpaste", "onpaste")}}</td>
  </tr>
 </tbody>
</table>

<p>If the cursor is in an editable context (for example, in a {{HTMLElement("textarea")}} or an element with <code><a href="/en-US/docs/Web/HTML/Global_attributes/contenteditable">contenteditable</a></code> attribute set to <code>true</code>) then the default action is to insert the contents of the clipboard into the document at the cursor position.</p>

<p>A handler for this event can access the clipboard contents by calling {{domxref("DataTransfer/getData", "getData()")}} on the event's <code>clipboardData</code> property.</p>

<p>To override the default behavior (for example to insert some different data or a transformation of the clipboard contents) an event handler must cancel the default action using {{domxref("Event/preventDefault", "event.preventDefault()")}}, and then insert its desired data manually.</p>

<p>It's possible to construct and dispatch a <a href="/en-US/docs/Web/Guide/Events/Creating_and_triggering_events">synthetic</a> <code>paste</code> event, but this will not affect the document's contents.</p>

<h2 id="Example">Example</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;svg viewBox="0 0 140 30" width="600" height="320" xmlns="http://www.w3.org/2000/svg"&gt;
    &lt;foreignObject x="5" y="-10" width="90" height="20"&gt;
        &lt;input xmlns="http://www.w3.org/1999/xhtml" value="Copy this text"/&gt;
    &lt;/foreignObject&gt;
    &lt;text x="5" y="30" id="element-to-paste-text" tabindex="1"&gt;Paste it here&lt;/text&gt;
&lt;/svg&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">input {
  font-size: 10px;
  width: 100%;
  height: 90%;
  box-sizing: border-box;
  border: 1px solid black;
}</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">document.getElementById("element-to-paste-text").addEventListener("paste", evt =&gt; {
  evt.target.textContent = evt.clipboardData.getData("text/plain").toUpperCase();
  evt.preventDefault();
});</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example", "620", "340")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "types.html#SVGDOMDependencies")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Definition that the clipboard events apply to SVG elements.</td>
  </tr>
  <tr>
   <td>{{SpecName("Clipboard API", "#clipboard-event-paste")}}</td>
   <td>{{Spec2("Clipboard API")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.SVGGraphicsElement.paste_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related events: <code><a href="/en-US/docs/Web/API/SVGGraphicsElement/cut_event">cut</a></code>, <code><a href="/en-US/docs/Web/API/SVGGraphicsElement/copy_event">copy</a></code></li>
 <li>This event on HTML {{domxref("Element")}} targets: <code><a href="/en-US/docs/Web/API/Element/paste_event">paste</a></code></li>
 <li>This event on {{domxref("Document")}} targets: <code><a href="Web/API/Document/paste_event">paste</a></code></li>
 <li>This event on {{domxref("Window")}} targets: <code><a href="Web/API/Window/paste_event">paste</a></code></li>
</ul>
